/***************************************************************************
 *   Copyright (C) 2004 by Nilesh Bansal                                   *
 *   nilesh@iitb.ac.in                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef FTPMONITOR_H
#define FTPMONITOR_H

#include <Plasma/PopupApplet>
#include <QStringListModel>
#include <QTreeWidget>
#include <QTableWidget>
#include <QGraphicsTextItem>

#include "ui_ftpmonitorConfig.h"

#include "ftpmonitorloop.h"
#include "ftpserver/proftpdmonitor.h"
#include "ftpserver/ncftpdmonitor.h"
#include "ftpserver/vsftpdmonitor.h"
#include "ftpserver/pureftpdmonitor.h"

/**
 * Main part of FTPMonitor is mListView which cointain rows of connected clients, FTPMonitor class manipulate
 * with these rows trought delRow, addRow, changeRow slots
 * Panel icon of applet is changed in clientsCountChanged ( using QPainter and  drawText two times )
 * Contain also overrided createConfigurationInterface and configAccepted for interacation with config widget
 */
class FTPMonitor : public Plasma::PopupApplet
{
Q_OBJECT
	 
public:
	FTPMonitor(QObject *parent, const QVariantList &args);
	~FTPMonitor();

	enum SpecificRoles {
		ProfilesName = Qt::UserRole+1
	};
	/**
	 *
	 */	
	virtual void init();
	/**
	 *
	 */
	virtual QWidget *widget();
	/**
	 *
	 */
	virtual void createConfigurationInterface(KConfigDialog *parent);
	/**
	 *
	 */
	FTPMonitorLoop *newFtpMonitor(FTPMonitorLoop::FtpServerType ftpType,QString whoPath,bool useSudo);
public slots:
  	/**
	* save config settings and restart ftpmonitor loop with this new settings
	*/
	void configAccepted();
	/**
	 * 
	 */
	void clearClientsTable();
	/**
	 *
	 */
	void newClientsConnected(int count);
	/**
	 *
	 */
	void setSystrayIcon(int);
	/**
	 *
	 */
	void errorOccurs(int,QString);
	/**
	 *
	 */
	void delRow(int row);
	/**
	 *
	 */
	void addRow(QStringList row);
	/**
	 *
	 */
	void changeRow(QStringList,int);
	/**
	 *
	 */
	void btnconfFtpdTypeToggled(bool checked);
private:
	/**
	 *
	 */
	bool checkFtpWhoPath(bool usePat,QString whoPath,FTPMonitorLoop::FtpServerType ftpServer);
	/**
	 *
	 */
	void setHeaderLabels(FTPMonitorLoop::FtpServerType ftpServer);
	/**
	 *
	 */
	bool mShowNumberInSystray;
	/**
	 *
	 */
	QTreeWidget *mListView;
	/**
	 *
	 */
	FTPMonitorLoop * mMonitorLoop;
	/**
	 *
	 */
	Ui::formFtpMonitorConfig mUiConfig;
};

// This is the command that links your applet to the .desktop file
K_EXPORT_PLASMA_APPLET(ftpmonitor, FTPMonitor)

#endif
